from Globals           import DTMLFile
from OFS.ObjectManager import ObjectManager

class SubObjectTypeSupport:
    ''' '''

    possible_meta_types = ObjectManager.all_meta_types

    selected_meta_types = ()

    manage_options = ( {'label':'Sub-Objects', 'action':'manage_subObjectTypes',}, )

    __ac_permissions__ = ( ('View management screens', ('manage_subObjectTypes',
                                                        'manage_editSelectedMetaTypes')), )

    manage_subObjectTypes = DTMLFile('dtml/subObjectTypes', globals())


    def all_meta_types(self):
        ''' '''
        mt = []

        for meta_type in self.possible_meta_types():
            if meta_type['name'] in self.selected_meta_types:
                mt.append(meta_type)

        if not mt:
            mt = self.possible_meta_types()

        return mt


    def edit_selected_meta_types(self, meta_types):
        ''' '''
        try:
            self.selected_meta_types = tuple(meta_types)
        except:
            pass


    def manage_editSelectedMetaTypes(self, REQUEST):
        ''' '''
        if REQUEST.has_key('selected_meta_types'):
            self.edit_selected_meta_types(REQUEST['selected_meta_types'])

        if REQUEST:
            return self.manage_subObjectTypes(self, REQUEST)
